ModuleMainClass (Apache Commons BCEL 6.6.1 API)

org.apache.bcel.classfile

## Class ModuleMainClass

- java.lang.Object
- - org.apache.bcel.classfile.Attribute
  - - org.apache.bcel.classfile.ModuleMainClass

- All Implemented Interfaces:
    Cloneable, Node

      public final class ModuleMainClass
      extends Attribute

  This class is derived from Attribute and indicates the main class of a module. There may be at most one ModuleMainClass attribute in a ClassFile structure.
  See Also:
    `Attribute`

- - ### Field Summary

    - ### Fields inherited from class org.apache.bcel.classfile.Attribute

      `constant_pool, EMPTY_ARRAY, length, name_index, tag`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ModuleMainClass(int nameIndex, int length, int mainClassIndex, ConstantPool constantPool)`
    `ModuleMainClass(ModuleMainClass c)` Initialize from another object.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `accept(Visitor v)` Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class.
    `Attribute` | `copy(ConstantPool constantPool)`
    `void` | `dump(DataOutputStream file)` Dump ModuleMainClass attribute to file stream in binary format.
    `int` | `getHostClassIndex()`
    `void` | `setHostClassIndex(int mainClassIndex)`
    `String` | `toString()`

    - ### Methods inherited from class org.apache.bcel.classfile.Attribute

      `addAttributeReader, addAttributeReader, clone, getConstantPool, getLength, getName, getNameIndex, getTag, println, readAttribute, readAttribute, removeAttributeReader, setConstantPool, setLength, setNameIndex`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ModuleMainClass

          public ModuleMainClass(int nameIndex,
                                 int length,
                                 int mainClassIndex,
                                 ConstantPool constantPool)

      Parameters:
        `nameIndex` - Index in constant pool
        `length` - Content length in bytes
        `mainClassIndex` - Host class index
        `constantPool` - Array of constants

    - #### ModuleMainClass

          public ModuleMainClass(ModuleMainClass c)

      Initialize from another object. Note that both objects use the same references (shallow copy). Use copy() for a physical copy.

  - ### Method Detail

    - #### accept

          public void accept(Visitor v)

      Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class. I.e., the hierarchy of methods, fields, attributes, etc. spawns a tree of objects.
      Specified by:
        `accept` in interface `Node`
      Specified by:
        `accept` in class `Attribute`
      Parameters:
        `v` - Visitor object

    - #### copy

          public Attribute copy(ConstantPool constantPool)

      Specified by:
        `copy` in class `Attribute`
      Returns:
        deep copy of this attribute

    - #### dump

          public void dump(DataOutputStream file)
                    throws IOException

      Dump ModuleMainClass attribute to file stream in binary format.
      Overrides:
        `dump` in class `Attribute`
      Parameters:
        `file` - Output file stream
      Throws:
        `IOException` - if an I/O error occurs.

    - #### getHostClassIndex

          public int getHostClassIndex()

      Returns:
        index into constant pool of host class name.

    - #### setHostClassIndex

          public void setHostClassIndex(int mainClassIndex)

      Parameters:
        `mainClassIndex` - the host class index

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Attribute`
      Returns:
        String representation

Copyright © 2004–2022 The Apache Software Foundation. All rights reserved.